/* upnp.js - API library for UPnP configuration */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01a,6OCT10,mvb  written. 
*/

function upnpStatusCheck ()
	{
	var upnpStatus = radioCheckedValueGet ('upnp.upnpEnable');
	if (!upnpStatus) return;
	
	switch (parseInt (upnpStatus, 10))
		{
		case 1:	/* ENABLED */
			fieldStateChangeWr ('','','txtAdvPeriod txtAdvTime','');
			break;
		case 0: /* DISABLED */
			fieldStateChangeWr ('txtAdvPeriod txtAdvTime','','','');
			break;
		default:
			break;
		}
	
	}
	
function upnpStatusCheckOnload ()
	{
	var upnpStatus = document.getElementById('hdUpnpEnable');
	if (!upnpStatus) return;
	var upnpStatusVal = upnpStatus.value;
	switch (parseInt (upnpStatusVal, 10))
		{
		case 1:	/* ENABLED */
			fieldStateChangeWr ('','','txtAdvPeriod txtAdvTime','upnpPortTbl');
			break;
		case 0: /* DISABLED */
			fieldStateChangeWr ('txtAdvPeriod txtAdvTime','upnpPortTbl','','');
			break;
		default:
			break;
		}
	
	}

function upnpConfValidate ()
	{
	/* L10N Error Message Collection Start */
     var errMsgL10n1 ='Please enter valid advertisement period.';
     var errMsgL10n2 ='Invalid advertisement period.';
     var errMsgL10n3 ='in minutes.';
     var errMsgL10n4 ='Please enter valid advertisement TTL.';    
     var errMsgL10n5 ='Invalid advertisement TTL.';
     var errMsgL10n6 ='in hops.';
     /* L10N Error Message Collection End */

	var upnpStatus = radioCheckedValueGet ('upnp.upnpEnable');
	if (!upnpStatus) return;
	
	/* return from here if UPnP is disabled */
	if (parseInt (upnpStatus, 10) == 0)
		return true;

    var advObj = document.getElementById('txtAdvPeriod');
    if (advObj && !advObj.disabled)
    {
    if (numericValueRangeCheck (advObj, 1, 
                                errMsgL10n1,
                                1, 1440, true, errMsgL10n2," "+errMsgL10n3) == false)
        return false;
    }
	
    var advObj = document.getElementById('txtAdvTime');
    if (advObj && !advObj.disabled)
    {
    if (numericValueRangeCheck (advObj, 1, 
                                errMsgL10n4,
                                1, 255, true, errMsgL10n5, " "+errMsgL10n6) == false)
        return false;
    }
		
	return true;
	}
