/* wan_mode.js - API library for wan mode configuration */

/* Copyright 2011 TeamF1, Inc. */
/*
modification history 
------------------------
01a, 19Aug11, Smita P, Modified functions to accomodate Load Balancing Section
*/

var wanLst = null;
var wanValueLst = null;

/******************************************************************** 
* deleteOptions - inner functions ussage
* 
* This routine validates Mtu Size based on IspType selected
* 
* RETURNS: TRUE or FALSE 
*/
function deleteOptions (selObj)
    {
    while(selObj.options.length != 0)
        selObj.options[0]=null;
    }
    
function updateWAN ()
    {
    var primaryObj = document.getElementById ('selPrimWan');
    if (!primaryObj) return;
    var secondary = document.getElementById ('selSecondary');
    if (!secondary) return;
    var secondarySelected = comboSelectedValueGet ('selSecondary');
    deleteOptions (secondary)
    for (var idx = 0, i = 0; i < primaryObj.options.length; i++)
        {
        if (primaryObj.value != wanValueLst[i])
            secondary.options [idx++] = new Option(wanLst[i], wanValueLst[i], false, (secondarySelected == wanValueLst[i]));
        }
    }
    
function portMode ()
    {
    var selValue = radioCheckedValueGet ('WanMode.Wanmode');
    if (!selValue) return;
    switch (parseInt(selValue, 10))
        {
        case 0:        /* Primary WAN Mode */
            fieldStateChangeWr ('selAutoRollover','','selPrimWan chkAutoRollover selSecondary','');
            failoverCheck ();
            break;
        case 1:        /* Load Balancing */
            fieldStateChangeWr ('selPrimWan chkAutoRollover selSecondary','','selAutoRollover','');
            break;
        }  
    }
    
function failoverCheck ()
    {
    depFieldCheck ('chkAutoRollover', true, '', '', 'selSecondary', '');
    depFieldCheck ('chkAutoRollover', false, 'selSecondary', '', '', '');
    }
    
function checkIdleTimeoutFalg ()
    {
    if(document.getElementById('hdWanmLBIdleStatus') && document.getElementById('hdWanmLBIdleStatus').value == 1)
        {
        // Idle timeout is not allowed in LB mode
        fieldStateChangeWr ('rdbLoadBalance', '', '', '');
        }
    }
    
function wanModeInitalSettings (frmReset)
    {
    var ipModeObj = document.getElementById ('hdIpMode');
    
    var secWanObj = document.getElementById ('selSecondary');
    if (!frmReset && secWanObj)
        {
        wanLst = new Array();
        wanValueLst = new Array();
        for (idx = 0; idx < secWanObj.options.length; idx++)
            {
            wanLst[idx] = secWanObj.options[idx].text;
            wanValueLst[idx] = secWanObj.options[idx].value;
            }
        }
    if (ipModeObj && ipModeObj.value == "1")
        {
        var chkFailoverObj = document.getElementById ('chkAutoRollover');
        if (chkFailoverObj.checked)
            {
            document.getElementById('rdbSingleWan').checked = true;
            }
        failoverCheck ();
        updateWAN ();
        checkIdleTimeoutFalg ();
        portMode ();
        wanIpModeCheck ();
        }
    else
        {
        document.getElementById('rdbSingleWan').checked = true;
        fieldStateChangeWr ('rdbLoadBalance selAutoRollover', '', 'selPrimWan', '');
        failoverCheck ();
        }
    }

function wanModeValidate ()
    {
    var errMsgL10n1 ='WAN1 Failure detection method is configured as None. Cannot set WAN1 as Primary WAN';     
    var errMsgL10n2 ='WAN2 Failure detection method is configured as None. Cannot set WAN2 as Primary WAN';     
    var errMsgL10n3 ='WAN3 Failure detection method is configured as None. Cannot set WAN3 as Primary WAN';     
    var errMsgL10n4 ='WAN4 Failure detection method is configured as None. Cannot set WAN4 as Primary WAN';
    
    var primWanObj = document.getElementById ('selPrimWan');
    var autoRollObj = document.getElementById ('chkAutoRollover');
    if (!primWanObj || !autoRollObj) return true;
    if ((primWanObj && primWanObj.disabled) || (autoRollObj && !autoRollObj.checked)) return true;
    var primWan =  primWanObj.value;
    var failureDetectMethodObj = null
    if (primWan == "WAN1")
        {
        failureDetectMethodObj = document.getElementById ('hdWan1FailDetection');
        if (failureDetectMethodObj && failureDetectMethodObj.value == "0")
            {
            alert (errMsgL10n1);
            primWanObj.focus ();
            return false
            }
        }
    else if (primWan == "WAN2")
        {
        failureDetectMethodObj = document.getElementById ('hdWan2FailDetection');
        if (failureDetectMethodObj && failureDetectMethodObj.value == "0")
            {
            alert (errMsgL10n2);
            primWanObj.focus ();
            return false
            }
        }
    else if (primWan == "WAN3")
        {
        failureDetectMethodObj = document.getElementById ('hdWan3FailDetection');
        if (failureDetectMethodObj && failureDetectMethodObj.value == "0")
            {
            alert (errMsgL10n3);
            primWanObj.focus ();
            return false
            }
        }
    else if (primWan == "WAN4")
        {
        failureDetectMethodObj = document.getElementById ('hdWan4FailDetection');
        if (failureDetectMethodObj && failureDetectMethodObj.value == "0")
            {
            alert (errMsgL10n4);
            primWanObj.focus ();
            return false
            }
        }
        
    return true;
    }
    
/* This function checks the IP Mode and sets 
   the Load Balance and Auto Rollover to disable if ipv4/ipv6 mode 
*/	
function wanIpModeCheck ()
	{
	var grayoutFlag = document.getElementById ('hdGrayout');
	if (!grayoutFlag) return;
	if (grayoutFlag.value == "1")
		fieldStateChangeWr('rdbIpv4or6','','','');
	}

/*
   This function enables only primary wan on Load Balancing Settings clicking IP Mode as IPV4/IPV6
   other wise enable.
   returns empty;
*/
function checkRoutingMode ()
    {
        var ipMode = radioCheckedValueGet ("networkInfo.netWorkMode");
        if(ipMode == "3")
            {
            if (confirm("Selecting Routing Mode as IPv4/IPv6 mode will set Load Balancing Settings to Primary WAN Mode. Do you want to continue?"))
                {
                document.getElementById('rdbSingleWan').checked = true;
                fieldStateChangeWr ('rdbLoadBalance selAutoRollover', '', 'selPrimWan', '');
                }
            else
               {
               document.getElementById('rdbIpv4').checked = true;
               fieldStateChangeWr ('', '', 'rdbLoadBalance selAutoRollover', '');
               }
            }
        else
            {
               fieldStateChangeWr ('', '', 'rdbLoadBalance selAutoRollover', '');
            }
        var chkFailoverObj = document.getElementById ('chkAutoRollover');
        if (chkFailoverObj.checked) {
            document.getElementById('rdbSingleWan').checked = true;
        }
        failoverCheck ();
        updateWAN ();
        checkIdleTimeoutFalg ();
        portMode ();
        wanIpModeCheck ();
        return;
    }
